<template>
  <main>
    <div class="px-0 pt-4 pb-20">
      <div class="w-full max-w-full px-8 py-0 m-auto my-0">
        <div class="relative flex flex-wrap items-center justify-between mb-6">
          <h1 class="page__title">
            {{ $t("account") }}
          </h1>
          <button
            class="text-2xl text-[#b3b6bc] logout-button1"
            @click="onLogout"
          >
            <img
              class=""
              :src="
                getAssetImage(
                  'assets/theme/black_modern_1/images/profileMenu/sign-out.svg'
                )
              "
              alt=""
            />
          </button>
        </div>
        <div class="profile__wrapper">
          <div>
            <div class="form__block--avatar">
              <div
                v-if="isSuspended"
                class="flex p-0 w-full bg-[var(--background-body)] rounded-2xl"
              >
                <h2>{{ $t("account_is_suspended") }}</h2>
              </div>
              <div
                v-if="!isSuspended"
                class="flex mb-6 p-0 w-full bg-[var(--background-body)] rounded-2xl"
              >
                <div class="flex-shrink-0">
                  <div
                    class="w-[80px] h-[80px] border-[var(--element-border-color)] border-[2px] box-shadow-inset rounded-[40px] relative"
                  >
                    <img
                      class="w-full h-full object-scale-down rounded-[50%]"
                      :src="
                        getAssetImage(
                          'assets/theme/black_modern_1/images/profileMenu/avatar.svg'
                        )
                      "
                      alt=""
                    />
                  </div>
                </div>
                <div class="flex flex-col justify-center w-full ml-4">
                  <div
                    class="font-bold text-[24px] mb-1 text-[var(--title-font-color)] items-center"
                  >
                    {{ username }}
                  </div>
                  <div
                    class="text-sm flex items-center text-[#707585] uppercase"
                  >
                    ID: {{ customerId }}
                  </div>
                </div>
                <button
                  class="text-2xl text-[#b3b6bc] logout-button2 self-start w-[10%]"
                  @click="onLogout"
                >
                  <img
                    class=""
                    :src="
                      getAssetImage(
                        'assets/theme/black_modern_1/images/profileMenu/sign-out.svg'
                      )
                    "
                    alt=""
                  />
                </button>
              </div>
              <div
                v-if="!isSuspended"
                class="flex items-center justify-between w-full mb-6"
              >
                <div
                  class="text-sm w-full leading-[1.5] bg-[var(--background-body)] box-shadow rounded-xl"
                >
                  <el-collapse v-model="activeNames" accordion>
                    <div class="">
                      <div class="">
                        <el-collapse-item name="balance" class="balance-item">
                          <template #title>
                            <div
                              class="pl-4 text-[24px] leading-[32px] font-bold text-[var(--title-font-color)] cursor-pointer relative flex justify-between items-center min-h-[64px] py-4 pr-[60px] w-full"
                            >
                              <span>
                                {{ currency }}:
                                {{ formatCredit(wallets[0]?.BetCredit) }}
                              </span>
                              <div
                                class="absolute top-4 right-4 w-8 h-8 rounded-2xl text-[#707585] bg-[var(--button-bg)] box-shadow flex items-center justify-center balance__icon"
                              ></div>
                            </div>
                          </template>
                          <div
                            class="opacity-100 p-4 text-sm box-shadow-inset text-[var(--title-font-color)] rounded-b-xl balance-item__content"
                          >
                            <div class="flex items-center justify-between">
                              <span>{{ $t("wallet") }}</span>
                              <div>
                                <span>
                                  {{ $t("refresh") }}
                                </span>
                                <button
                                  class="text-[4vw] text-[var(--title-font-color)] ml-2"
                                  @click="getBalance"
                                >
                                  <icons
                                    :is-refresh="true"
                                    class="block w-3 h-[14px]"
                                  />
                                </button>
                              </div>
                            </div>
                            <div
                              class="bg-[#ccc] my-[5px] w-full h-[1px]"
                            ></div>
                            <div
                              v-for="wallet in allWallets"
                              :key="wallet.WalletName"
                            >
                              <div
                                class="flex items-center justify-between pb-1"
                              >
                                <span class="text-[var(--title-font-color)]">{{
                                  wallet.getWalletNameForDisplay()
                                }}</span>
                                <span class="text-[var(--title-font-color)]">{{
                                  formatCredit(wallet?.BetCredit)
                                }}</span>
                              </div>
                            </div>
                          </div>
                        </el-collapse-item>
                      </div>
                    </div>
                  </el-collapse>
                </div>
              </div>
            </div>
          </div>
          <div class="max-w-full">
            <ul class="profile-menu">
              <li class="profile-menu__item">
                <nuxt-link
                  :to="BET_HISTORY_ROUTES.INDEX"
                  class="w-full h-full flex items-center font-medium text-base leading-5 text-[var(--title-font-color)] p-4"
                >
                  <img
                    class="w-6 h-6 mr-[10px]"
                    :src="
                      getAssetImage(
                        'assets/theme/black_modern_1/images/profileMenu/bet-history.svg'
                      )
                    "
                    alt=""
                  />
                  <span class="">{{ $t("bet_history") }}</span>
                  <font-awesome-icon
                    icon="arrow-right"
                    class="ml-auto mr-0 text-[var(--title-font-color)] leading-normal text-2xl"
                  />
                </nuxt-link>
              </li>
              <li class="profile-menu__item">
                <nuxt-link
                  to="/transaction-history"
                  class="w-full h-full flex items-center font-medium text-base leading-5 text-[var(--title-font-color)] p-4"
                >
                  <img
                    class="w-6 h-6 mr-[10px]"
                    :src="
                      getAssetImage(
                        'assets/theme/black_modern_1/images/profileMenu/statement.svg'
                      )
                    "
                    alt=""
                  />
                  <span class="">{{ $t("statement") }}</span>
                  <font-awesome-icon
                    icon="arrow-right"
                    class="ml-auto mr-0 text-[var(--title-font-color)] leading-normal text-2xl"
                  />
                </nuxt-link>
              </li>
              <li class="profile-menu__item">
                <nuxt-link
                  to="/wallet"
                  class="w-full h-full flex items-center font-medium text-base leading-5 text-[var(--title-font-color)] p-4"
                >
                  <img
                    class="w-6 h-6 mr-[10px]"
                    :src="
                      getAssetImage(
                        'assets/theme/black_modern_1/images/profileMenu/wallet.svg'
                      )
                    "
                    alt=""
                  />
                  <span class="">{{ $t("wallet") }}</span>
                  <font-awesome-icon
                    icon="arrow-right"
                    class="ml-auto mr-0 text-[var(--title-font-color)] leading-normal text-2xl"
                  />
                </nuxt-link>
              </li>
              <li v-if="referralEnabled" class="profile-menu__item">
                <nuxt-link
                  to="/referral"
                  class="w-full h-full flex items-center font-medium text-base leading-5 text-[var(--title-font-color)] p-4"
                >
                  <img
                    class="w-6 h-6 mr-[10px]"
                    :src="
                      getAssetImage(
                        'assets/theme/black_modern_1/images/profileMenu/referral.png'
                      )
                    "
                    alt=""
                  />
                  <span class="">{{ $t("referral") }}</span>
                  <font-awesome-icon
                    icon="arrow-right"
                    class="ml-auto mr-0 text-[var(--title-font-color)] leading-normal text-2xl"
                  />
                </nuxt-link>
              </li>
              <li>
                <nuxt-link
                  to="/messages"
                  class="w-full h-full flex items-center font-medium text-base leading-5 text-[var(--title-font-color)] p-4"
                >
                  <SvgIcon
                    svg-name="message"
                    class="w-6 h-6 mr-[10px]"
                  ></SvgIcon>
                  <span class="">{{ $t("messages") }}</span>
                  <MessagesMessageCount
                    v-if="unreadInfo && unreadInfo.TotalCount"
                    :count="unreadInfo.TotalCount"
                    :is-unread="true"
                    class="mr-2"
                  ></MessagesMessageCount>
                  <font-awesome-icon
                    icon="arrow-right"
                    class="ml-auto mr-0 text-[var(--title-font-color)] leading-normal text-2xl"
                  />
                </nuxt-link>
              </li>
              <li v-if="!agentCooperation.IsHidden" class="profile-menu__item">
                <nuxt-link
                  to="/agent-cooperation"
                  class="w-full h-full flex items-center font-medium text-base leading-5 text-[var(--title-font-color)] p-4"
                >
                  <img
                    class="w-6 h-6 mr-[10px]"
                    :src="
                      getAssetImage(
                        'assets/theme/black_modern_1/images/profileMenu/agent.svg'
                      )
                    "
                    alt=""
                  />
                  <span class="">{{ $t("agent_cooperation") }}</span>
                  <font-awesome-icon
                    icon="arrow-right"
                    class="ml-auto mr-0 text-[var(--title-font-color)] leading-normal text-2xl"
                  />
                </nuxt-link>
              </li>
            </ul>
          </div>
        </div>
      </div>
    </div>
  </main>
</template>

<script lang="ts" setup>
import { useHeaderComponent } from "@/composables/useTheme";
import { store } from "@/store";
import useBalanceInfo from "@/composables/useBalanceInfo";
import commonHelper from "@/utils/commonHelper";
import { Wallet } from "~~/models/common/wallet";
const { $t } = useNuxtApp();
const activeNames = ref([]);
const username = computed(() =>
  store.state.auth ? store.state.username : $t("anonymous_user")
);
const { logout, referralEnabled, agentCooperation } = useHeaderComponent();
const onLogout = () => {
  logout();
};
const { getBalance, currency, wallets } = useBalanceInfo();
const allWallets = computed(() =>
  wallets.value.map((wallet) => new Wallet(wallet))
);
const { getAssetImage } = commonHelper;
const customerId = computed(() => store.state.customerId);
const isSuspended = computed(() => store.state.isSuspended);
const route = useRoute();
const { fetchMessages, unreadInfo } = useMessage();
onMounted(() => {
  if (!route.fullPath.includes("messages")) {
    fetchMessages();
  }
});
function formatCredit(num: string | number) {
  if (!num) return "0.00";

  const number = `${num}`.trim().toString();
  if (Number.isNaN(Number(number))) return "0.00";

  const split = number.split(".");
  if (split.length === 1) {
    return `${number}.00`;
  }
  if (split.length > 1) {
    return `${split[0]}.${split[1].substring(0, 2).padEnd(2, "0")}`;
  }
  return "0.00";
}
</script>

<style lang="scss" scoped>
.el-collapse {
  --el-collapse-content-bg-color: none;
  --el-collapse-header-bg-color: none;
  border: none;

  :deep(.el-collapse-item__arrow) {
    font-weight: bold;
    color: var(--text);
  }
}

.icon-lang {
  img {
    width: 100%;
    height: 100%;
    border-radius: 50%;
    object-fit: contain;
  }

  height: 21.83px;
  width: 21.83px;
  border-radius: 50%;
  background-color: var(--textBtn);
}

.profile__wrapper {
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-orient: vertical;
  -webkit-box-direction: normal;
  -ms-flex-direction: column;
  flex-direction: column;
  width: 100%;
}

@supports (display: grid) {
  .profile__wrapper {
    display: grid;
    grid-template-columns: repeat(3, 1fr);
    grid-column-gap: 40px;

    @media (max-width: 1440px), (orientation: portrait) {
      grid-template-columns: 1fr 1fr;
    }

    @media (max-width: 1220px) {
      grid-gap: 20px;
    }

    @media (max-width: 980px) {
      grid-template-columns: 1fr;
    }
  }
}

.logout-button1 {
  display: none;
}

@media (max-width: 480px) {
  .logout-button1 {
    display: block;
  }

  .logout-button2 {
    display: none;
  }
}

.form__block--avatar {
  width: 100%;
  background: var(--background-body);
  -webkit-box-shadow: var(--box-shadow);
  box-shadow: var(--box-shadow);
  border-radius: 16px;
  margin-bottom: 16px;
  padding: 24px 32px;

  @media (max-width: 480px) {
    -webkit-box-shadow: none;
    box-shadow: none;
    margin-bottom: 24px;
    padding: 0;
  }
}

.el-collapse-item.balance-item {
  width: 100%;
  font-size: 21px;
  line-height: 1.5;
  background: var(--background-body);
  -webkit-box-shadow: var(--box-shadow);
  box-shadow: var(--box-shadow);
  border-radius: 12px;
}

.balance__icon {
  position: absolute;
  top: 16px;
  right: 16px;
  width: 32px;
  height: 32px;
  border-radius: 16px;
  color: var(--text);
  background: var(--button-bg);
  -webkit-box-shadow: var(--box-shadow);
  box-shadow: var(--box-shadow);
  -webkit-transition: -webkit-transform 0.2s ease-out;
  transition: -webkit-transform 0.2s ease-out;
  transition: transform 0.2s ease-out;
  transition: transform 0.2s ease-out, -webkit-transform 0.2s ease-out;
}

.el-collapse-item .balance-item__content {
  padding: 16px;
  -webkit-box-shadow: var(--box-shadow-inset);
  box-shadow: var(--box-shadow-inset);
  border-radius: 0 0 12px 12px;
  font-size: 16px;
  line-height: 24px;
  color: var(--title-font-color);

  @media (max-width: 767px) {
    font-size: 14px;
    line-height: 20px;
  }

  @media (max-width: 480px) {
    padding-left: 16px;
  }
}

.profile-menu {
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-orient: vertical;
  -webkit-box-direction: normal;
  -ms-flex-direction: column;
  flex-direction: column;
  -webkit-box-pack: start;
  -ms-flex-pack: start;
  justify-content: flex-start;
  -webkit-box-align: start;
  -ms-flex-align: start;
  align-items: flex-start;
}

.profile-menu__item {
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-align: center;
  -ms-flex-align: center;
  align-items: center;
  -webkit-box-pack: justify;
  -ms-flex-pack: justify;
  justify-content: space-between;
  width: 100%;
  background: var(--background-body);
  border: 2px solid var(--element-border-color);
  -webkit-box-sizing: border-box;
  box-sizing: border-box;
  -webkit-box-shadow: var(--box-shadow);
  box-shadow: var(--box-shadow);
  border-radius: 8px;
  position: relative;
  cursor: pointer;
  margin-bottom: 16px;
  -webkit-transition: 0.3s all;
  transition: 0.3s all;

  &:hover,
  &:focus {
    background: var(--primary);
  }

  a {
    width: 100%;
    height: 100%;
    display: -webkit-box;
    display: -ms-flexbox;
    display: flex;
    -webkit-box-align: center;
    -ms-flex-align: center;
    align-items: center;
    font-weight: 500;
    font-size: 16px;
    line-height: 20px;
    color: var(--title-font-color);
    -webkit-transition: none;
    transition: none;
    padding: 16px;

    &:hover,
    &:focus {
      color: var(--button-bg);
    }
  }
}

.page__title {
  width: auto;
  margin: 0;
  font-size: 44px;
  line-height: 52px;
  font-style: normal;
  font-weight: 700;
  -webkit-transition: color 0.4s;
  transition: color 0.4s;
  color: var(--title-font-color);

  @media (max-width: 767px) {
    font-size: 24px;
    line-height: 32px;
  }
}
</style>
<style lang="scss">
.profile-info__buttons_1 {
  transition: all 0.5s;
  cursor: pointer;
  border-radius: 6px;
  user-select: none;
  padding: 0 20px;
  white-space: nowrap;
  overflow: hidden;
  font-weight: 600;
  text-decoration: none;
  justify-content: center;
  height: 40px;
  font-size: 14px;
  align-items: center;
  display: inline-flex;
  background: var(--button-bg);
}

.profile-info__buttons {
  transition: all 0.5s;
  cursor: pointer;
  border-radius: 6px;
  user-select: none;
  padding: 0 20px;
  white-space: nowrap;
  overflow: hidden;
  font-weight: 600;
  text-decoration: none;
  justify-content: center;
  height: 40px;
  font-size: 14px;
  align-items: center;
  display: inline-flex;
  background: var(--primary);
}

.el-collapse-item__arrow {
  display: none;
}

.el-collapse-item.is-active .el-collapse-item__header,
.el-collapse-item__wrap {
  border-bottom: 1px solid var(--border);
}

.el-collapse-item__header,
.el-collapse-item__wrap {
  border-bottom: unset;
}

.el-collapse-item__header {
  height: 64px;
}

.el-collapse-item__header.is-active .balance__icon {
  transition: transform 0.3s ease-in-out;
}

.el-collapse-item__header.is-active .balance__icon {
  transform: rotate(0deg);
}

.el-collapse-item__header .balance__icon {
  transition: transform 0.3s ease-in-out;
}

.el-collapse-item__header .balance__icon {
  transform: rotate(45deg);

  &::before {
    content: "\00D7";
    font-size: 24px;
  }
}

.el-collapse-item__content {
  padding-bottom: 0;
}
</style>
